diff --git a/shared/js/weston.ruter.net/webforms2/webforms2_src.js b/shared/js/weston.ruter.net/webforms2/webforms2_src.js
index f15d8ee..5a8b110 100644
--- a/shared/js/weston.ruter.net/webforms2/webforms2_src.js
+++ b/shared/js/weston.ruter.net/webforms2/webforms2_src.js
@@ -2917,91 +2090,234 @@ $wf2 = {
 		//};
 	
 		return err;
-	}
-}; //End $wf2 = {
-
-
-/*##############################################################################################
- # Section: Repetition Model Definitions
- ##############################################################################################*/
-
-var RepetitionElement = {
-	REPETITION_NONE:0,
-	REPETITION_TEMPLATE:1,
-	REPETITION_BLOCK:2
-};
-
-var RepetitionEvent = {
-	//the following takes a UIEvent and adds the required properties for a RepetitionEvent
-	_upgradeEvent : function(){
-		this.initRepetitionEvent = RepetitionEvent.initRepetitionEvent;
-		this.initRepetitionEventNS = RepetitionEvent.initRepetitionEventNS;
 	},
-	initRepetitionEvent : function(typeArg, canBubbleArg, cancelableArg, elementArg){
-		if(this.initEvent)
-			this.initEvent(typeArg, canBubbleArg, cancelableArg);
-		else { //manually initialize event (i.e., for MSIE)
-			this.type = typeArg;
-	//		switch(typeArg.toLowerCase()){
-	//			case 'added':
-	//				this.type = 'add';
-	//				break;
-	//			case 'removed':
-	//				this.type = 'remove';
-	//				break;
-	//			case 'moved':
-	//				this.type = 'move';
-	//				break;
-	//		}
-			//this.srcElement = elementArg.repetitionTemplate;
-			//this.cancelBubble = false;
-			//this.cancelable = cancelableArg;
-			//this.returnValue = false;
+	
+	css: new function () {
+		var me = this;
+		
+		var blankRe = new RegExp('\\s');
+
+		/**
+		 * Generates a regular expression string that can be used to detect a class name
+		 * in a tag's class attribute.  It is used by a few methods, so I 
+		 * centralized it.
+		 * 
+		 * @param {String} className - a name of a CSS class.
+		 */
+		
+		function getClassReString(className) {
+			return '\\s'+className+'\\s|^' + className + '\\s|\\s' + className + '$|' + '^' + className +'$';
+		}
+		
+		function getClassPrefixReString(className) {
+			return '\\s'+className+'-[0-9a-zA-Z_]+\\s|^' + className + '[0-9a-zA-Z_]+\\s|\\s' + className + '[0-9a-zA-Z_]+$|' + '^' + className +'[0-9a-zA-Z_]+$';
+		}
+		
+		
+		/**
+		 * Make an HTML object be a member of a certain class.
+		 * 
+		 * @param {Object} obj - an HTML object
+		 * @param {String} className - a CSS class name.
+		 */
+		me.addClass = function (obj, className) {
 			
-			if(!this.preventDefault)
-			this.preventDefault = function(){
-				this.returnValue = false;
-			};
-			if(!this.stopPropagation)
-			this.stopPropagation = function(){
-				this.cancelBubble = true;
+			if (blankRe.test(className)) {
+				return;
+			}
+			
+			// only add class if the object is not a member of it yet.
+			if (!me.isMemberOfClass(obj, className)) {
+				obj.className += " " + className;
+			}
+			
+		}
+		
+		/**
+		 * Make an HTML object *not* be a member of a certain class.
+		 * 
+		 * @param {Object} obj - an HTML object
+		 * @param {Object} className - a CSS class name.
+		 */
+		me.removeClass = function (obj, className) {
+			
+			if (blankRe.test(className)) {
+				return; 
+			}
+			
+			
+			var re = new RegExp(getClassReString(className) , "g");
+			
+			var oldClassName = obj.className;
+		
+		
+			if (obj.className) {
+				obj.className = oldClassName.replace(re, ' ');
+			}
+		
+			
+		}
+		
+		/**
+		 * Determines if an HTML object is a member of a specific class.
+		 * @param {Object} obj - an HTML object.
+		 * @param {Object} className - the CSS class name.
+		 */
+		me.isMemberOfClass = function (obj, className) {
+			
+			if (blankRe.test(className))
+				return false;
+			
+			var re = new RegExp(getClassReString(className) , "g");
+		
+			return (re.test(obj.className));
+		
+		
+		}
+		
+		me.getAbsoluteCoords = function(obj) {
+		
+			var curleft = obj.offsetLeft;
+			var curtop = obj.offsetTop;
+			
+			/*
+			 * IE and Gecko
+			 */
+			if (obj.getBoundingClientRect) {
+				var temp = obj.getBoundingClientRect();
+				
+				curleft = temp.left + me.getScrollX();
+				curtop = temp.top + me.getScrollY();
+			} else {
+			
+				/* Everything else must do the quirkmode.org way */
+			
+				if (obj.offsetParent) {
+				
+					while (obj = obj.offsetParent) {
+						curleft += obj.offsetLeft - obj.scrollLeft;
+						curtop += obj.offsetTop - obj.scrollTop;
+					}
+				}
+			}
+			return {
+				x: curleft,
+				y: curtop
 			};
 		}
-		this.element = elementArg;
-		this.relatedNode = elementArg; //for Opera (deprecated?)
-	},
-	initRepetitionEventNS : function(namespaceURIArg, typeArg, canBubbleArg, cancelableArg, elementArg){
-		throw Error("NOT IMPLEMENTED: RepetitionEvent.initRepetitionEventNS");
-		//this.initEvent(namespaceURIArg, typeArg, canBubbleArg, cancelableArg);
-		//this.element = elementArg;
-		//this.relatedNode = elementArg; //for Opera (deprecated?)
+		
+		/**
+		 * Get the the amount of pixels the window has been scrolled from the top.  If there is no
+		 * vertical scrollbar, this function return 0.
+		 *
+		 * @return {int} - the amount of pixels the window has been scrolled to the right, in pixels.
+		 */
+		me.getScrollX = function (myWindow)
+		{
+			var myDocument;
+			
+			if (myWindow) {
+				myDocument = myWindow.document;
+			} else {
+				myWindow = window;
+				myDocument = document;
+			}
+			
+			// All except that I know of except IE
+			if (myWindow.pageXOffset != null) {
+				return myWindow.pageXOffset;
+			// IE 6.x strict
+			} else if (myDocument.documentElement != null 
+					&& myDocument.documentElement.scrollLeft !="0px" 
+						&& myDocument.documentElement.scrollLeft !=0)  {
+				return myDocument.documentElement.scrollLeft;
+			// all other IE
+			} else if (myDocument.body != null && 
+				myDocument.body.scrollLeft != null) {
+				return myDocument.body.scrollLeft;
+			// if for some reason none of the above work, this should.
+			} else if (myWindow.scrollX != null) {
+				return myWindow.scrollX;
+			} else {
+				return null;
+			}
+		}
+		
+		/**
+		 * Get the the amount of pixels the window has been scrolled to the right.  If there is no
+		 * horizontal scrollbar, this function return 0.
+		 * 
+		 * @return {int} - the amount of pixels the window has been scrolled to the right, in pixels.
+		 */
+		me.getScrollY = function(myWindow)
+		{
+			var myDocument;
+			
+			if (myWindow) {
+				myDocument = myWindow.document;
+			} else {
+				myWindow = window;
+				myDocument = document;
+			}
+			
+			// All except that I know of except IE
+			if (myWindow.pageYOffset != null) {
+				return myWindow.pageYOffset;
+			// IE 6.x strict
+			} else if (myDocument.documentElement != null
+					&& myDocument.documentElement.scrollTop !="0px" 
+						&& myDocument.documentElement.scrollTop !=0) {
+				return myDocument.documentElement.scrollTop;
+			// all other IE
+			} else if (myDocument.body && myDocument.body.scrollTop != null) { 
+				return myDocument.body.scrollTop;
+			// if for some reason none of the above work, this should.
+			} else if (myWindow.scrollY != null) { 
+				return myWindow.scrollY;
+			} else {
+				return null;
+			}
+		}
+		
+		/**
+		 * gets the current window's height.  
+		 * 
+		 * @author Peter-Paul Koch - http://www.quirksmode.org
+		 * @license see http://www.quirksmode.org/about/copyright.html
+		 * @return {int} - the window's height in pixels.
+		 */
+		me.getWindowHeight = function  (theWindow)
+		{
+			if (!theWindow) {
+				theWindow = window;
+			}
+				
+			var theDocument = theWindow.document;
+			
+			// all except IE
+			if (theWindow.innerHeight != null) {
+				return theWindow.innerHeight;
+			// IE6 Strict mode
+			} else if (theDocument.documentElement && 
+					theDocument.documentElement.clientHeight ) {
+				return theDocument.documentElement.clientHeight;
+			// IE strictly less than 6
+			} else if (theDocument.body != null) {
+				return theDocument.body.clientHeight;
+			} else {
+				return null;
+			}
+		}
 	}
-};
+}; //End $wf2 = {
+
+
+
 
 /*##############################################################################################
  # Change the prototypes of HTML elements
  ##############################################################################################*/
 
-//RepetitionElement interface must be implemented by all elements.
-if(window.Element && Element.prototype){
-	Element.prototype.REPETITION_NONE     = RepetitionElement.REPETITION_NONE;
-	Element.prototype.REPETITION_TEMPLATE = RepetitionElement.REPETITION_TEMPLATE;
-	Element.prototype.REPETITION_BLOCK    = RepetitionElement.REPETITION_BLOCK;
-	
-	Element.prototype.repetitionType      = RepetitionElement.REPETITION_NONE;
-	Element.prototype.repetitionIndex     = 0;
-	Element.prototype.repetitionTemplate  = null; /*readonly*/
-	Element.prototype.repetitionBlocks    = null; /*readonly*/
-
-	Element.prototype.repeatStart = 1;
-	Element.prototype.repeatMin   = 0;
-	Element.prototype.repeatMax   = Number.MAX_VALUE; //Infinity;
-	
-	Element.prototype.addRepetitionBlock        = $wf2.addRepetitionBlock;
-	Element.prototype.addRepetitionBlockByIndex = $wf2.addRepetitionBlockByIndex;
-	Element.prototype.moveRepetitionBlock       = $wf2.moveRepetitionBlock;
-	Element.prototype.removeRepetitionBlock     = $wf2.removeRepetitionBlock;
-}
 
 /*##############################################################################################
  # Set mutation event handlers to automatically add WF2 behaviors
@@ -3111,8 +2427,10 @@ else if(/MSIE/i.test(navigator.userAgent) && !document.addEventListener && windo
 			
 			//See issue #3 <http://code.google.com/p/repetitionmodel/issues/detail?id=3>
 			//Sometimes cssQuery doesn't find all repetition templates from here within this DOMContentLoaded substitute
-			if($wf2.repetitionTemplates.length == 0)
-				$wf2.isInitialized = false;
+			if (window.$wf2Rep) {
+				if($wf2.repetitionTemplates.length == 0)
+					$wf2.isInitialized = false;
+			}
 		}
 	};
 	script = null;
@@ -3135,51 +2453,12 @@ if(!eventSet){
 })();
 } //End If(!document.implementation...
 
-/*##############################################################################################
- # Extensions for existing Web Forms 2.0 Implementations
- ##############################################################################################*/
-else if(document.addEventListener && ($wf2.oldRepetitionEventModelEnabled === undefined || $wf2.oldRepetitionEventModelEnabled)){
-	$wf2.oldRepetitionEventModelEnabled = true;
-	(function(){
-		
-	var deprecatedAttrs = {
-		added   : 'onadd',
-		removed : 'onremove',
-		moved   : 'onmove'
-	};
-	
-	function handleRepetitionEvent(evt){
-		if(!$wf2.oldRepetitionEventModelEnabled)
-			return;
-		if(!evt.element && evt.relatedNode) //Opera uses evt.relatedNode instead of evt.element as the specification dictates
-			evt.element = evt.relatedNode;
-		if(!evt.element || !evt.element.repetitionTemplate)
-			return;
-		
-		var rt = evt.element.repetitionTemplate;
-		var attrName = 'on' + evt.type;
-		
-		//Add support for event handler set with HTML attribute
-		var handlerAttr = rt.getAttribute(attrName) || /* deprecated */ rt.getAttribute(deprecatedAttrs[evt.type]);
-		if(handlerAttr && (!rt[attrName] || typeof rt[attrName] != 'function')) //in MSIE, attribute == property
-			rt[attrName] = new Function('event', handlerAttr);
-		
-		if(evt.element.repetitionTemplate[attrName])
-			evt.element.repetitionTemplate[attrName](evt);
-		else if(evt.element.repetitionTemplate[deprecatedAttrs[evt.type]]) //deprecated
-			evt.element.repetitionTemplate[deprecatedAttrs[evt.type]](evt);
-	}
-	
-	document.addEventListener('added', handleRepetitionEvent, false);
-	document.addEventListener('removed', handleRepetitionEvent, false);
-	document.addEventListener('moved', handleRepetitionEvent, false);
-	
-	})();
-}
+
 
 } //end if(!window.$wf2)
 
 
+
 //if(!window.ValidityState){
 	//var ValidityState = {
 	//	
@@ -3204,6 +2483,6 @@ else if(document.addEventListener && ($wf2.oldRepetitionEventModelEnabled === un
 	
 //}
 
-//if(!window.HTMLOutputElement){
+//if(!window.HTMLOutputElement){ 
 	
 //}
